!function (t) {
    function r(n) {
        if (e[n]) return e[n].exports;
        var o = e[n] = {exports: {}, id: n, loaded: !1};
        return t[n].call(o.exports, o, o.exports, r), o.loaded = !0, o.exports
    }

    var e = {};
    return r.m = t, r.c = e, r.p = "", r(0)
}([function (t, r, e) {
    e(1)(window)
}, function (t, r) {
    t.exports = function (t) {
        t.hookAjax = function (t) {
            function r(r) {
                return function () {
                    var e = this.hasOwnProperty(r + "_") ? this[r + "_"] : this.xhr[r], n = (t[r] || {}).getter;
                    return n && n(e, this) || e
                }
            }

            function e(r) {
                return function (e) {
                    var n = this.xhr, o = this, i = t[r];
                    if ("function" == typeof i) n[r] = function () {
                        t[r](o) || e.apply(n, arguments)
                    }; else {
                        var a = (i || {}).setter;
                        e = a && a(e, o) || e;
                        try {
                            n[r] = e
                        } catch (t) {
                            this[r + "_"] = e
                        }
                    }
                }
            }

            function n(r) {
                return function () {
                    var e = [].slice.call(arguments);
                    if (!t[r] || !t[r].call(this, e, this.xhr)) {
                        return this.xhr[r].apply(this.xhr, e)
                    }
                }
            }

            window._ahrealxhr = window._ahrealxhr || XMLHttpRequest, XMLHttpRequest = function () {
                var t = new window._ahrealxhr;
                Object.defineProperty(this, "xhr", {value: t,writable: false})
            };
            var o = window._ahrealxhr.prototype;
            for (var i in o) {
                var a = "";
                try {
                    a = typeof o[i]
                } catch (t) {
                }
                "function" === a ? XMLHttpRequest.prototype[i] = n(i) : Object.defineProperty(XMLHttpRequest.prototype, i, {
                    get: r(i),
                    set: e(i),
                    enumerable: !0
                })
            }
            return window._ahrealxhr
        }, t.unHookAjax = function () {
            window._ahrealxhr && (XMLHttpRequest = window._ahrealxhr), window._ahrealxhr = void 0
        }, t.default = t
    }
}]);


(function () {
    var SDK_ERR_LOG_ADDRESS = 'https://log.public.sdk.gzyouai.com/el/log'


    function post_err_log(last_xhr, msg) {
	
        try {
            var _xhr = new window._ahrealxhr();
            var host_array = last_xhr.responseURL.split(/:\/\//)
            var host = host_array[1].split(/\//)[0]
            var protocol = host_array[0]
            var app_id = window.localStorage.getItem('app_id') || 'sdk_error'
            var data = [{
                "index_type": "sdk_error",
                "href": window.location.href, //当前地址
                "method": last_xhr.method,         //上次的请求方式
                "gameSimpleName": app_id,
                "sdkSimpleName": host,
                "sdkVersionCode": protocol,
                "body": window.localStorage.getItem('data_/sdk/login/json') || 'data_/sdk/pay/json',
                "create_time": new Date().getTime(),
                "req": {
                    "data": last_xhr.post_data,
                    "url": last_xhr.url
                },
                "rsp": {
                    "result_code": last_xhr.status,  //上次返回的code
                    "message": msg,//上次返回的信息
                    "response": last_xhr.responseText
                }
            }]
            _xhr.open("post", SDK_ERR_LOG_ADDRESS, true);
            _xhr.send(JSON.stringify(data));
        } catch (e) {
            console.log('post_err_log error ', e)
        }

    }

    //https://github.com/wendux/Ajax-hook
    hookAjax({
        //拦截回调
        onreadystatechange: function (xhr) {
            //XMLHttpRequest处理完成

            if (xhr.readyState == xhr.DONE) {
                var url = xhr.xhr.responseURL
                var post_data = xhr.xhr.post_data
                if (xhr.status == 0) {
                    //网络错误
                    post_err_log(xhr.xhr, "网络错误")
                } else {
                    try {
                        var data = JSON.parse(xhr.xhr.responseText || xhr.responseText || null)
                        if (data.code != 0) {
                            //返回错误
                            var msg = data.msg
                            post_err_log(xhr.xhr, msg)
                        }
                    } catch (e) {
                        post_err_log(xhr.xhr, e.message)
                    }
                }


            }

        },

        //拦截方法
        open: function (arg, xhr) {
            xhr.method = arg[0]
            xhr.url = arg[1]
            console.log("open called: method:%s,url:%s,async:%s", arg[0], arg[1], arg[2], arg)
        },
        send: function (arg, xhr) {
            xhr.post_data = arg[0]
            console.log("send called: method:%s,url:%s,async:%s", arg[0], arg[1], arg[2], arg)
        }
    })

})();